from herschel.hifi.pipeline.level0 import DoPointingTask
#
# Get data, after entering HSA username and password 
# Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.login_usr", "username") 
# Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.login_pwd", "password")
# Alternatively you can set these in your .hcss/user.props file as:
# hcss.ia.pal.pool.hsa.haio.apply_authentication=true    
# hcss.ia.pal.pool.hsa.haio.login_usr = username    
# hcss.ia.pal.pool.hsa.haio.login_pwd = password
#
obs = getObservation("obsid", useHsa=True)
#
doPointing=DoPointingTask()
lev0=obs.getProduct("level0")
# This script fails if you do not have data from all spectrometers so, in the 
# line below, list the spectrometers you DO have data from in your observation
#
# Note that in HIPE 4.2 some warning messages of the type  "Exceptions while 
# retrieving information from PointingProduct on commanding. Latest error was: 
# java.lang.IllegalArgumentException: Column name 'rasterLineNum' already exists." 
#  These messages can be safely ignored and the issue is fixed in HIPE 5.0.
for htpname in ["WBS-V", "WBS-H", "HRS-H", "HRS-V"]:
  htp=lev0.getProduct(htpname)
# The new option is useSynt; set this to 0 to calculate the H and V positions or 
# set it to 1 to use the synthesised aperture 
  htp=doPointing(htp=htp,useIntegration=1,  aux=obs.auxiliary, useSynt=0)
  lev0.setProduct(htpname,htp)
obs.setProduct("level0",lev0)
# The next command runs the pipeline, and overwrites your variable "obs"
obs=hifiPipeline(obs=obs, fromLevel=0, upToLevel=2, cal=1, save=False)

#
#Save observation, saveCalTree saves the calibration too, which is needed if you
# want to reprocess the data again
saveObservation(obs, poolName="MyPoolName",  saveCalTree=True)
